/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 22:22:26 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.admin.model;

/**
 * JSON template for MailItem object in Email Migration API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Email Migration API v2. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class MailItem extends com.google.api.client.json.GenericJson {

  /**
   * Boolean indicating if the mail is deleted (used in Vault)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isDeleted;

  /**
   * Boolean indicating if the mail is draft
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isDraft;

  /**
   * Boolean indicating if the mail is in inbox
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isInbox;

  /**
   * Boolean indicating if the mail is in 'sent mails'
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isSent;

  /**
   * Boolean indicating if the mail is starred
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isStarred;

  /**
   * Boolean indicating if the mail is in trash
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isTrash;

  /**
   * Boolean indicating if the mail is unread
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isUnread;

  /**
   * Kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * List of labels (strings)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> labels;

  /**
   * Boolean indicating if the mail is deleted (used in Vault)
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsDeleted() {
    return isDeleted;
  }

  /**
   * Boolean indicating if the mail is deleted (used in Vault)
   * @param isDeleted isDeleted or {@code null} for none
   */
  public MailItem setIsDeleted(java.lang.Boolean isDeleted) {
    this.isDeleted = isDeleted;
    return this;
  }

  /**
   * Boolean indicating if the mail is draft
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsDraft() {
    return isDraft;
  }

  /**
   * Boolean indicating if the mail is draft
   * @param isDraft isDraft or {@code null} for none
   */
  public MailItem setIsDraft(java.lang.Boolean isDraft) {
    this.isDraft = isDraft;
    return this;
  }

  /**
   * Boolean indicating if the mail is in inbox
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsInbox() {
    return isInbox;
  }

  /**
   * Boolean indicating if the mail is in inbox
   * @param isInbox isInbox or {@code null} for none
   */
  public MailItem setIsInbox(java.lang.Boolean isInbox) {
    this.isInbox = isInbox;
    return this;
  }

  /**
   * Boolean indicating if the mail is in 'sent mails'
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsSent() {
    return isSent;
  }

  /**
   * Boolean indicating if the mail is in 'sent mails'
   * @param isSent isSent or {@code null} for none
   */
  public MailItem setIsSent(java.lang.Boolean isSent) {
    this.isSent = isSent;
    return this;
  }

  /**
   * Boolean indicating if the mail is starred
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsStarred() {
    return isStarred;
  }

  /**
   * Boolean indicating if the mail is starred
   * @param isStarred isStarred or {@code null} for none
   */
  public MailItem setIsStarred(java.lang.Boolean isStarred) {
    this.isStarred = isStarred;
    return this;
  }

  /**
   * Boolean indicating if the mail is in trash
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsTrash() {
    return isTrash;
  }

  /**
   * Boolean indicating if the mail is in trash
   * @param isTrash isTrash or {@code null} for none
   */
  public MailItem setIsTrash(java.lang.Boolean isTrash) {
    this.isTrash = isTrash;
    return this;
  }

  /**
   * Boolean indicating if the mail is unread
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsUnread() {
    return isUnread;
  }

  /**
   * Boolean indicating if the mail is unread
   * @param isUnread isUnread or {@code null} for none
   */
  public MailItem setIsUnread(java.lang.Boolean isUnread) {
    this.isUnread = isUnread;
    return this;
  }

  /**
   * Kind of resource this is.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is.
   * @param kind kind or {@code null} for none
   */
  public MailItem setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * List of labels (strings)
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getLabels() {
    return labels;
  }

  /**
   * List of labels (strings)
   * @param labels labels or {@code null} for none
   */
  public MailItem setLabels(java.util.List<java.lang.String> labels) {
    this.labels = labels;
    return this;
  }

  @Override
  public MailItem set(String fieldName, Object value) {
    return (MailItem) super.set(fieldName, value);
  }

  @Override
  public MailItem clone() {
    return (MailItem) super.clone();
  }

}
